=== debian/changelog ===
hyprpicker (0.4.5-1) unstable; urgency=medium

  * Initial release. (Closes: #1117492)

 -- Carl Keinath <carl.keinath@gmail.com>  Mon, 06 Oct 2025 20:05:58 +0200
