=== debian/control ===
Source: hyprpicker
Section: x11
Priority: optional
Maintainer: Debian Hyprland Maintainers <team+hyprland@tracker.debian.org>
Uploaders:
 Carl Keinath <carl.keinath@gmail.com>,
 Chow Loong Jin <hyperair@debian.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libwayland-dev,
 wayland-protocols,
 libxkbcommon-dev,
 libcairo2-dev,
 libpango1.0-dev,
 libpangocairo-1.0-0,
 libjpeg-dev,
 libhyprutils-dev (>= 0.2.0),
 hyprwayland-scanner (>= 0.4.0)
Standards-Version: 4.7.2
Homepage: https://github.com/hyprwm/hyprpicker
Vcs-Browser: https://salsa.debian.org/hyprland-team/hyprpicker
Vcs-Git: https://salsa.debian.org/hyprland-team/hyprpicker.git

Package: hyprpicker
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: wlroots-compatible Wayland color picker
 Minimal color picker, that lets you select colors from the screen and output
 them in formats such as HEX, RGB, or HSL, with optional clipboard copy and
 zoom preview support.
