## hyprpicker 0.4.6

=== debian/changelog ===
hyprpicker (0.4.6-1) unstable; urgency=medium

  * New upstream release

 -- Chow Loong Jin <hyperair@debian.org>  Wed, 11 Feb 2026 15:36:57 +0800
