=== debian/control ===
--- 
+++ 
@@ -14,7 +14,6 @@
  libxkbcommon-dev,
  libcairo2-dev,
  libpango1.0-dev,
- libpangocairo-1.0-0,
  libjpeg-dev,
  libhyprutils-dev (>= 0.2.0),
  hyprwayland-scanner (>= 0.4.0)
